
declare name "freeverb" ; 
declare version "1.0" ; 
declare author "Grame" ; 
declare license "BSD" ; 
declare copyright "(c)GRAME 2006" ; 












fixedgain = 0.015 ; 
scalewet = 3.0 ; 
scaledry = 2.0 ; 
scaledamp = 0.4 ; 
scaleroom = 0.28 ; 
offsetroom = 0.7 ; 
initialroom = 0.5 ; 
initialdamp = 0.5 ; 
initialwet = 1.0 / scalewet ; 
initialdry = 0 ; 
initialwidth = 1.0 ; 
initialmode = 0.0 ; 
freezemode = 0.5 ; 
stereospread = 23 ; 
allpassfeed = 0.5 ; 





combtuningL1 = 1116 ; 
combtuningL2 = 1188 ; 
combtuningL3 = 1277 ; 
combtuningL4 = 1356 ; 
combtuningL5 = 1422 ; 
combtuningL6 = 1491 ; 
combtuningL7 = 1557 ; 
combtuningL8 = 1617 ; 

allpasstuningL1 = 556 ; 
allpasstuningL2 = 441 ; 
allpasstuningL3 = 341 ; 
allpasstuningL4 = 225 ; 









dampSlider = hslider ( "Damp" , 0.5 , 0 , 1 , 0.025 ) * scaledamp ; 
roomsizeSlider = hslider ( "RoomSize" , 0.8 , 0 , 1 , 0.025 ) * scaleroom + offsetroom ; 
wetSlider = hslider ( "Wet" , 0.8 , 0 , 1 , 0.025 ) ; 
drySlider = hslider ( "Dry" , 0 , 0 , 1 , 0.025 ) ; 
combfeed = roomsizeSlider ; 










allpass ( dt , fb , input ) = (first_func__ ~ (_,_,_,_,_,_)) : return__ with{

first_func__(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output) = 
  if__(not_first_iteration__, func__606(1, buffer__pos, buffer__val, bufidx, bufout, output), func__606(1, buffer__pos, buffer__val, bufidx, bufout, output));

func__606(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output) = 
  func__607(not_first_iteration__, buffer__pos, buffer__val, bufidx, (rwtable(buffer__size, buffer__init, buffer__pos, buffer__val, (bufidx ))), output);

func__607(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output) = 
  func__608(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, (- input + bufout ));

func__608(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output) = 
  func__609(not_first_iteration__, (bufidx ), (input + (bufout * fb )), bufidx, bufout, output);

func__609(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output) = 
  func__610(not_first_iteration__, buffer__pos, buffer__val, bufidx+1, bufout, output);

func__610(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output) = 
  if__((bufidx >= dt ), func__611(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output), func__612(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output));

func__611(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output) = 
  func__613(not_first_iteration__, buffer__pos, buffer__val, (0 ), bufout, output);

func__613(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output) = 
  func__612(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output);

func__612(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output) = 
  (not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output, 0);

return__(not_first_iteration__, buffer__pos, buffer__val, bufidx, bufout, output, n__) = 
  (output );

buffer__size=(dt );
buffer__init= (0.0):float;
if__(a,(k1,k2),(k3,k4)) = if__(a,k1,k3),if__(a,k2,k4);
if__(a,k,k)             = k;
if__(a,k1,k2)           = select2(a,k2,k1);
} ; 























comb ( dt , fb , damp , input ) = (first_func__ ~ (_,_,_,_,_,_)) : return__ with{

first_func__(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output) = 
  if__(not_first_iteration__, func__614(1, buffer__pos, buffer__val, bufidx, filterstore, output), func__614(1, buffer__pos, buffer__val, bufidx, filterstore, output));

func__614(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output) = 
  func__615(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, (rwtable(buffer__size, buffer__init, buffer__pos, buffer__val, (bufidx ))));

func__615(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output) = 
  func__616(not_first_iteration__, buffer__pos, buffer__val, bufidx, ((output * (1 - damp ))+ (filterstore * damp )), output);

func__616(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output) = 
  func__617(not_first_iteration__, (bufidx ), (input + (filterstore * fb )), bufidx, filterstore, output);

func__617(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output) = 
  func__618(not_first_iteration__, buffer__pos, buffer__val, bufidx+1, filterstore, output);

func__618(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output) = 
  if__((bufidx >= dt ), func__619(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output), func__620(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output));

func__619(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output) = 
  func__621(not_first_iteration__, buffer__pos, buffer__val, (0 ), filterstore, output);

func__621(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output) = 
  func__620(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output);

func__620(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output) = 
  (not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output, 0);

return__(not_first_iteration__, buffer__pos, buffer__val, bufidx, filterstore, output, n__) = 
  (output );

buffer__size=(dt );
buffer__init= (0.0):float;
if__(a,(k1,k2),(k3,k4)) = if__(a,k1,k3),if__(a,k2,k4);
if__(a,k,k)             = k;
if__(a,k1,k2)           = select2(a,k2,k1);
} ; 























monoReverb ( fb1 , fb2 , damp , spread ) 
= _ <: comb ( combtuningL1 + spread , fb1 , damp ) , 
comb ( combtuningL2 + spread , fb1 , damp ) , 
comb ( combtuningL3 + spread , fb1 , damp ) , 
comb ( combtuningL4 + spread , fb1 , damp ) , 
comb ( combtuningL5 + spread , fb1 , damp ) , 
comb ( combtuningL6 + spread , fb1 , damp ) , 
comb ( combtuningL7 + spread , fb1 , damp ) , 
comb ( combtuningL8 + spread , fb1 , damp ) 
+> 
allpass ( allpasstuningL1 + spread , fb2 ) 
: allpass ( allpasstuningL2 + spread , fb2 ) 
: allpass ( allpasstuningL3 + spread , fb2 ) 
: allpass ( allpasstuningL4 + spread , fb2 ) 
; 

stereoReverb ( fb1 , fb2 , damp , spread ) 
= + <: monoReverb ( fb1 , fb2 , damp , 0 ) , monoReverb ( fb1 , fb2 , damp , spread ) ; 





fxctrl ( g , w , Fx ) = _ , _ <: ( * ( g ) , * ( g ) : Fx : * ( w ) , * ( w ) ) , * ( 1 - w ) , * ( 1 - w ) +> _ , _ ; 






freeverb = vgroup ( "Freeverb" , fxctrl ( fixedgain , wetSlider , stereoReverb ( combfeed , allpassfeed , dampSlider , stereospread ) ) ) ; 

process = freeverb ; 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
